Index: code/branches/objecthierarchy/src/orxonox/objects/worldentities/PositionableEntity.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/worldentities/PositionableEntity.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/worldentities/PositionableEntity.h	(revision 2019)
@@ -38,5 +38,5 @@
     {
         public:
-            PositionableEntity();
+            PositionableEntity(BaseObject* creator);
             virtual ~PositionableEntity();
 
Index: code/branches/objecthierarchy/src/orxonox/objects/worldentities/SpawnPoint.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/worldentities/SpawnPoint.cc	(revision 2019)
+++ code/branches/objecthierarchy/src/orxonox/objects/worldentities/SpawnPoint.cc	(revision 2019)
@@ -0,0 +1,91 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "SpawnPoint.h"
+
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+#include "objects/gametypes/Gametype.h"
+
+namespace orxonox
+{
+    CreateFactory(SpawnPoint);
+
+    SpawnPoint::SpawnPoint(BaseObject* creator) : PositionableEntity(creator)
+    {
+        RegisterObject(SpawnPoint);
+
+        this->template_ = 0;
+
+        if (this->getGametype())
+            this->getGametype()->registerSpawnPoint(this);
+        else
+            COUT(1) << "Error: SpawnPoint has no Gametype" << std::endl;
+
+        this->setObjectMode(0x0);
+    }
+
+    void SpawnPoint::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(SpawnPoint, XMLPort, xmlelement, mode);
+
+        XMLPortParam(SpawnPoint, "spawnclass", setSpawnClassName, getSpawnClassName, xmlelement, mode);
+        XMLPortParam(SpawnPoint, "design", setTemplateName, getTemplateName, xmlelement, mode);
+    }
+
+    void SpawnPoint::setSpawnClassName(const std::string& name)
+    {
+        this->spawnclassname_ = name;
+        this->spawnclass_ = ClassByString(name);
+    }
+
+    void SpawnPoint::setTemplateName(const std::string& name)
+    {
+        this->templatename_ = name;
+        this->template_ = Template::getTemplate(name);
+    }
+
+    ControllableEntity* SpawnPoint::spawn()
+    {
+        ControllableEntity* entity = this->spawnclass_.fabricate(this);
+        if (entity)
+        {
+            this->spawn(entity);
+            if (this->template_)
+                entity->addTemplate(this->template_);
+        }
+        return entity;
+    }
+
+    void SpawnPoint::spawn(ControllableEntity* entity)
+    {
+        entity->setPosition(this->getPosition());
+        entity->setOrientation(this->getOrientation());
+    }
+}
Index: code/branches/objecthierarchy/src/orxonox/objects/worldentities/SpawnPoint.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/worldentities/SpawnPoint.h	(revision 2019)
+++ code/branches/objecthierarchy/src/orxonox/objects/worldentities/SpawnPoint.h	(revision 2019)
@@ -0,0 +1,78 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _SpawnPoint_H__
+#define _SpawnPoint_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "core/Identifier.h"
+#include "core/Template.h"
+#include "PositionableEntity.h"
+#include "ControllableEntity.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport SpawnPoint : public PositionableEntity
+    {
+        public:
+            SpawnPoint(BaseObject* creator);
+            virtual ~SpawnPoint() {}
+
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+            inline void setSpawnClass(Identifier* identifier)
+                { this->spawnclass_ = identifier; this->spawnclassname_ = identifier->getName(); }
+            inline Identifier* getSpawnClass() const
+                { return this->spawnclass_; }
+
+            inline void setTemplate(Template* temp)
+                { this->template_ = temp; this->templatename_ = temp->getName(); }
+            inline Template* getTemplate() const
+                { return this->template_; }
+
+            ControllableEntity* spawn();
+            void spawn(ControllableEntity* entity);
+
+        public:
+            void setSpawnClassName(const std::string& name);
+            inline const std::string& getSpawnClassName() const
+                { return this->spawnclassname_; }
+
+            void setTemplateName(const std::string& name);
+            inline const std::string& getTemplateName() const
+                { return this->templatename_; }
+
+            SubclassIdentifier<ControllableEntity> spawnclass_;
+            std::string spawnclassname_;
+            Template* template_;
+            std::string templatename_;
+    };
+}
+
+#endif /* _SpawnPoint_H__ */
Index: code/branches/objecthierarchy/src/orxonox/objects/worldentities/WorldEntity.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/worldentities/WorldEntity.cc	(revision 2019)
@@ -30,4 +30,5 @@
 #include "WorldEntity.h"
 
+#include <cassert>
 #include <OgreSceneManager.h>
 
@@ -37,4 +38,5 @@
 
 #include "GraphicsEngine.h"
+#include "objects/Scene.h"
 
 namespace orxonox
@@ -47,9 +49,13 @@
     const Vector3 WorldEntity::UP    = Vector3::UNIT_Y;
 
-    WorldEntity::WorldEntity()
+    WorldEntity::WorldEntity(BaseObject* creator) : BaseObject(creator)
     {
         RegisterObject(WorldEntity);
 
-        this->node_ = GraphicsEngine::getInstance().getLevelSceneManager()->getRootSceneNode()->createChildSceneNode();
+        assert(this->getScene());
+        assert(this->getScene()->getRootSceneNode());
+
+        this->node_ = this->getScene()->getRootSceneNode()->createChildSceneNode();
+
         this->parent_ = 0;
         this->parentID_ = (unsigned int)-1;
@@ -66,8 +72,8 @@
         {
             this->node_->detachAllObjects();
-            GraphicsEngine::getInstance().getLevelSceneManager()->destroySceneNode(this->node_->getName());
+            if (this->getScene()->getSceneManager())
+                this->getScene()->getSceneManager()->destroySceneNode(this->node_->getName());
         }
     }
-
 
     void WorldEntity::XMLPort(Element& xmlelement, XMLPort::Mode mode)
@@ -131,5 +137,5 @@
         object->parentID_ = (unsigned int)-1;
 
-        GraphicsEngine::getInstance().getLevelSceneManager()->getRootSceneNode()->addChild(object->node_);
+        this->getScene()->getRootSceneNode()->addChild(object->node_);
     }
 
Index: code/branches/objecthierarchy/src/orxonox/objects/worldentities/WorldEntity.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/worldentities/WorldEntity.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/worldentities/WorldEntity.h	(revision 2019)
@@ -45,5 +45,5 @@
     {
         public:
-            WorldEntity();
+            WorldEntity(BaseObject* creator);
             virtual ~WorldEntity();
 
Index: code/branches/objecthierarchy/src/orxonox/objects/worldentities/pawns/Spectator.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/worldentities/pawns/Spectator.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/worldentities/pawns/Spectator.cc	(revision 2019)
@@ -33,4 +33,6 @@
 #include "core/Core.h"
 #include "objects/worldentities/Model.h"
+#include "objects/Scene.h"
+#include "objects/infos/PlayerInfo.h"
 #include "tools/BillboardSet.h"
 
@@ -39,5 +41,5 @@
     CreateFactory(Spectator);
 
-    Spectator::Spectator()
+    Spectator::Spectator(BaseObject* creator) : ControllableEntity(creator)
     {
         RegisterObject(Spectator);
@@ -54,8 +56,9 @@
 
         // test test test
+        if (this->getScene()->getSceneManager())
         {
             this->testmesh_ = new Mesh();
             this->testnode_ = this->getNode()->createChildSceneNode();
-            this->testmesh_->setMeshSource("assff.mesh");
+            this->testmesh_->setMeshSource(this->getScene()->getSceneManager(), "assff.mesh");
             if (this->testmesh_->getEntity())
                 this->testnode_->attachObject(this->testmesh_->getEntity());
@@ -64,8 +67,13 @@
             this->testnode_->scale(10, 10, 10);
         }
+        else
+        {
+            this->testmesh_ = 0;
+            this->testnode_ = 0;
+        }
         // test test test
 
         this->greetingFlare_ = new BillboardSet();
-        this->greetingFlare_->setBillboardSet("Examples/Flare", ColourValue(1.0, 1.0, 0.8), Vector3(0, 20, 0), 1);
+        this->greetingFlare_->setBillboardSet(this->getScene()->getSceneManager(), "Examples/Flare", ColourValue(1.0, 1.0, 0.8), Vector3(0, 20, 0), 1);
         this->getNode()->attachObject(this->greetingFlare_->getBillboardSet());
         this->greetingFlare_->setVisible(false);
@@ -80,10 +88,20 @@
         if (this->isInitialized())
         {
-            delete this->greetingFlare_;
+            if (this->greetingFlare_)
+            {
+                this->getNode()->detachObject(this->greetingFlare_->getBillboardSet());
+                delete this->greetingFlare_;
+            }
 
             // test test test
             {
-                delete this->testmesh_;
-                delete this->testnode_;
+                if (this->testmesh_ && this->testnode_)
+                    this->testnode_->detachObject(this->testmesh_->getEntity());
+
+                if (this->testmesh_)
+                    delete this->testmesh_;
+
+                if (this->testnode_)
+                    this->getNode()->removeAndDestroyChild(this->testnode_->getName());
             }
             // test test test
@@ -177,4 +195,6 @@
     void Spectator::fire()
     {
+        if (this->getPlayer())
+            this->getPlayer()->setReadyToSpawn(true);
     }
 
Index: code/branches/objecthierarchy/src/orxonox/objects/worldentities/pawns/Spectator.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/objects/worldentities/pawns/Spectator.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/objects/worldentities/pawns/Spectator.h	(revision 2019)
@@ -39,5 +39,5 @@
     {
         public:
-            Spectator();
+            Spectator(BaseObject* creator);
             virtual ~Spectator();
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 2019)
@@ -55,6 +55,7 @@
     SetConsoleCommand(OrxonoxOverlay, rotateOverlay, false).accessLevel(AccessLevel::User);
 
-    OrxonoxOverlay::OrxonoxOverlay()
-        : overlay_(0)
+    OrxonoxOverlay::OrxonoxOverlay(BaseObject* creator)
+        : BaseObject(creator)
+        , overlay_(0)
         , background_(0)
     {
@@ -148,5 +149,5 @@
             return this->background_->getMaterialName();
         else
-            return blankString;
+            return BLANKSTRING;
     }
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/OrxonoxOverlay.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/OrxonoxOverlay.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/OrxonoxOverlay.h	(revision 2019)
@@ -84,5 +84,5 @@
 
     public:
-        OrxonoxOverlay();
+        OrxonoxOverlay(BaseObject* creator);
         virtual ~OrxonoxOverlay();
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/OverlayGroup.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/OverlayGroup.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/OverlayGroup.cc	(revision 2019)
@@ -50,5 +50,5 @@
     SetConsoleCommand(OverlayGroup, scrollGroup, false).accessLevel(AccessLevel::User);
 
-    OverlayGroup::OverlayGroup()
+    OverlayGroup::OverlayGroup(BaseObject* creator) : BaseObject(creator)
     {
         RegisterObject(OverlayGroup);
Index: code/branches/objecthierarchy/src/orxonox/overlays/OverlayGroup.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/OverlayGroup.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/OverlayGroup.h	(revision 2019)
@@ -54,5 +54,5 @@
     {
     public:
-        OverlayGroup();
+        OverlayGroup(BaseObject* creator);
         //! Empty destructor.
         ~OverlayGroup() { }
Index: code/branches/objecthierarchy/src/orxonox/overlays/OverlayText.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/OverlayText.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/OverlayText.cc	(revision 2019)
@@ -41,6 +41,5 @@
     CreateFactory(OverlayText);
 
-    OverlayText::OverlayText()
-        : text_(0)
+    OverlayText::OverlayText(BaseObject* creator) : OrxonoxOverlay(creator), text_(0)
     {
         RegisterObject(OverlayText);
@@ -60,5 +59,5 @@
         {
             this->text_ = static_cast<Ogre::TextAreaOverlayElement*>(Ogre::OverlayManager::getSingleton()
-                .createOverlayElement("TextArea", "OverlayText_text_" + getUniqueNumberStr()));
+                .createOverlayElement("TextArea", "OverlayText_text_" + getUniqueNumberString()));
             this->text_->setCharHeight(1.0);
 
@@ -84,5 +83,5 @@
             return this->text_->getFontName();
         else
-            return blankString;
+            return BLANKSTRING;
     }
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/OverlayText.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/OverlayText.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/OverlayText.h	(revision 2019)
@@ -42,5 +42,5 @@
     {
     public:
-        OverlayText();
+        OverlayText(BaseObject* creator);
         virtual ~OverlayText();
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugFPSText.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugFPSText.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugFPSText.cc	(revision 2019)
@@ -38,5 +38,5 @@
     CreateFactory(DebugFPSText);
 
-    DebugFPSText::DebugFPSText()
+    DebugFPSText::DebugFPSText(BaseObject* creator) : OverlayText(creator)
     {
         RegisterObject(DebugFPSText);
Index: code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugFPSText.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugFPSText.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugFPSText.h	(revision 2019)
@@ -40,5 +40,5 @@
     {
     public:
-        DebugFPSText();
+        DebugFPSText(BaseObject* creator);
         ~DebugFPSText();
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugRTRText.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugRTRText.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugRTRText.cc	(revision 2019)
@@ -38,5 +38,5 @@
     CreateFactory(DebugRTRText);
 
-    DebugRTRText::DebugRTRText()
+    DebugRTRText::DebugRTRText(BaseObject* creator) : OverlayText(creator)
     {
         RegisterObject(DebugRTRText);
Index: code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugRTRText.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugRTRText.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/debug/DebugRTRText.h	(revision 2019)
@@ -40,5 +40,5 @@
     {
     public:
-        DebugRTRText();
+        DebugRTRText(BaseObject* creator);
         ~DebugRTRText();
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/hud/ChatOverlay.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/hud/ChatOverlay.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/hud/ChatOverlay.cc	(revision 2019)
@@ -39,5 +39,5 @@
 
 #include "GraphicsEngine.h"
-#include "objects/infos/Level.h"
+#include "LevelManager.h"
 #include "objects/infos/PlayerInfo.h"
 #include "overlays/console/InGameConsole.h"
@@ -50,5 +50,5 @@
     CreateFactory(ChatOverlay);
 
-    ChatOverlay::ChatOverlay()
+    ChatOverlay::ChatOverlay(BaseObject* creator) : OverlayText(creator)
     {
         RegisterObject(ChatOverlay);
@@ -76,5 +76,5 @@
             std::string name = "unknown";
 
-            PlayerInfo* player = Level::getClient(senderID);
+            PlayerInfo* player = LevelManager::getInstance().getClient(senderID);
             if (player)
                 name = player->getName();
Index: code/branches/objecthierarchy/src/orxonox/overlays/hud/ChatOverlay.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/hud/ChatOverlay.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/hud/ChatOverlay.h	(revision 2019)
@@ -42,5 +42,5 @@
     {
         public:
-            ChatOverlay();
+            ChatOverlay(BaseObject* creator);
             ~ChatOverlay();
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDBar.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDBar.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDBar.cc	(revision 2019)
@@ -38,4 +38,5 @@
 
 #include "util/Convert.h"
+#include "util/String.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
@@ -45,6 +46,5 @@
     CreateFactory(BarColour);
 
-    BarColour::BarColour()
-        : position_(0.0)
+    BarColour::BarColour(BaseObject* creator) : BaseObject(creator), position_(0.0)
     {
         RegisterObject(BarColour);
@@ -63,7 +63,5 @@
     unsigned int HUDBar::materialcount_s = 0;
 
-    HUDBar::HUDBar()
-        : bar_(0)
-        , textureUnitState_(0)
+    HUDBar::HUDBar(BaseObject* creator) : OrxonoxOverlay(creator), bar_(0), textureUnitState_(0)
     {
         RegisterObject(HUDBar);
@@ -92,5 +90,5 @@
 
             this->bar_ = static_cast<Ogre::PanelOverlayElement*>(Ogre::OverlayManager::getSingleton()
-                .createOverlayElement("Panel", "HUDBar_bar_" + getUniqueNumberStr()));
+                .createOverlayElement("Panel", "HUDBar_bar_" + getUniqueNumberString()));
             this->bar_->setMaterialName(materialname);
             this->background_->addChild(bar_);
Index: code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDBar.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDBar.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDBar.h	(revision 2019)
@@ -44,5 +44,5 @@
     {
     public:
-        BarColour();
+        BarColour(BaseObject* creator);
         ~BarColour() { }
 
@@ -64,5 +64,5 @@
     {
     public:
-        HUDBar();
+        HUDBar(BaseObject* creator);
         virtual ~HUDBar();
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDNavigation.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDNavigation.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDNavigation.cc	(revision 2019)
@@ -46,6 +46,7 @@
     CreateFactory(HUDNavigation);
 
-    HUDNavigation::HUDNavigation()
-        : navMarker_(0)
+    HUDNavigation::HUDNavigation(BaseObject* creator)
+        : OrxonoxOverlay(creator)
+        , navMarker_(0)
         , aimMarker_(0)
         , navText_(0)
@@ -72,9 +73,9 @@
             // create nav text
             navText_ = static_cast<Ogre::TextAreaOverlayElement*>(Ogre::OverlayManager::getSingleton()
-                .createOverlayElement("TextArea", "HUDNavigation_navText_" + getUniqueNumberStr()));
+                .createOverlayElement("TextArea", "HUDNavigation_navText_" + getUniqueNumberString()));
 
             // create nav marker
             navMarker_ = static_cast<Ogre::PanelOverlayElement*>(Ogre::OverlayManager::getSingleton()
-                .createOverlayElement("Panel", "HUDNavigation_navMarker_" + getUniqueNumberStr()));
+                .createOverlayElement("Panel", "HUDNavigation_navMarker_" + getUniqueNumberString()));
             navMarker_->setMaterialName("Orxonox/NavArrows");
             wasOutOfView_ = true; // just to ensure the material is changed right the first time..
@@ -82,5 +83,5 @@
             // create aim marker
             aimMarker_ = static_cast<Ogre::PanelOverlayElement*>(Ogre::OverlayManager::getSingleton()
-                .createOverlayElement("Panel", "HUDNavigation_aimMarker_" + getUniqueNumberStr()));
+                .createOverlayElement("Panel", "HUDNavigation_aimMarker_" + getUniqueNumberString()));
             aimMarker_->setMaterialName("Orxonox/NavCrosshair");
 
@@ -112,5 +113,5 @@
             return this->navText_->getFontName();
         else
-            return blankString;
+            return BLANKSTRING;
     }
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDNavigation.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDNavigation.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDNavigation.h	(revision 2019)
@@ -41,5 +41,5 @@
     {
     public:
-        HUDNavigation();
+        HUDNavigation(BaseObject* creator);
         ~HUDNavigation();
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDRadar.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDRadar.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDRadar.cc	(revision 2019)
@@ -35,4 +35,5 @@
 
 #include "util/Math.h"
+#include "util/String.h"
 #include "core/ConsoleCommand.h"
 #include "core/CoreIncludes.h"
@@ -45,6 +46,5 @@
     CreateFactory(HUDRadar);
 
-    HUDRadar::HUDRadar()
-        : marker_(0)
+    HUDRadar::HUDRadar(BaseObject* creator) : OrxonoxOverlay(creator), marker_(0)
     {
         RegisterObject(HUDRadar);
@@ -69,5 +69,5 @@
         {
             marker_ = static_cast<Ogre::PanelOverlayElement*>(Ogre::OverlayManager::getSingleton()
-                .createOverlayElement("Panel", "HUDRadar_marker_" + getUniqueNumberStr()));
+                .createOverlayElement("Panel", "HUDRadar_marker_" + getUniqueNumberString()));
             marker_->setMaterialName("Orxonox/RadarMarker");
             overlay_->add2D(marker_);
@@ -107,5 +107,5 @@
             // we have to create a new entry
             panel = static_cast<Ogre::PanelOverlayElement*>(
-                Ogre::OverlayManager::getSingleton().createOverlayElement("Panel", "RadarDot" + getUniqueNumberStr()));
+                Ogre::OverlayManager::getSingleton().createOverlayElement("Panel", "RadarDot" + getUniqueNumberString()));
             radarDots_.push_back(panel);
             // get right material
Index: code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDRadar.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDRadar.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDRadar.h	(revision 2019)
@@ -45,5 +45,5 @@
     {
     public:
-        HUDRadar();
+        HUDRadar(BaseObject* creator);
         ~HUDRadar();
 
Index: code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDSpeedBar.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDSpeedBar.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDSpeedBar.cc	(revision 2019)
@@ -36,5 +36,5 @@
     CreateFactory(HUDSpeedBar);
 
-    HUDSpeedBar::HUDSpeedBar()
+    HUDSpeedBar::HUDSpeedBar(BaseObject* creator) : HUDBar(creator)
     {
         RegisterObject(HUDSpeedBar);
Index: code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDSpeedBar.h
===================================================================
--- code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDSpeedBar.h	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/overlays/hud/HUDSpeedBar.h	(revision 2019)
@@ -41,5 +41,5 @@
     {
     public:
-        HUDSpeedBar();
+        HUDSpeedBar(BaseObject* creator);
         ~HUDSpeedBar();
 
Index: code/branches/objecthierarchy/src/orxonox/tools/BillboardSet.cc
===================================================================
--- code/branches/objecthierarchy/src/orxonox/tools/BillboardSet.cc	(revision 2013)
+++ code/branches/objecthierarchy/src/orxonox/tools/BillboardSet.cc	(revision 2019)
@@ -31,5 +31,5 @@
 
 #include <sstream>
-
+#include <cassert>
 #include <OgreSceneManager.h>
 
@@ -46,44 +46,60 @@
     }
 
-    void BillboardSet::setBillboardSet(const std::string& file, int count)
+    void BillboardSet::setBillboardSet(Ogre::SceneManager* scenemanager, const std::string& file, int count)
     {
+        assert(scenemanager);
+
         std::ostringstream name;
         name << (BillboardSet::billboardSetCounter_s++);
-        this->billboardSet_ = GraphicsEngine::getInstance().getLevelSceneManager()->createBillboardSet("Billboard" + name.str(), count);
+        this->billboardSet_ = scenemanager->createBillboardSet("Billboard" + name.str(), count);
         this->billboardSet_->createBillboard(Vector3::ZERO);
         this->billboardSet_->setMaterialName(file);
+
+        this->scenemanager_ = scenemanager;
     }
 
-    void BillboardSet::setBillboardSet(const std::string& file, const ColourValue& colour, int count)
+    void BillboardSet::setBillboardSet(Ogre::SceneManager* scenemanager, const std::string& file, const ColourValue& colour, int count)
     {
+        assert(scenemanager);
+
         std::ostringstream name;
         name << (BillboardSet::billboardSetCounter_s++);
-        this->billboardSet_ = GraphicsEngine::getInstance().getLevelSceneManager()->createBillboardSet("Billboard" + name.str(), count);
+        this->billboardSet_ = scenemanager->createBillboardSet("Billboard" + name.str(), count);
         this->billboardSet_->createBillboard(Vector3::ZERO, colour);
         this->billboardSet_->setMaterialName(file);
+
+        this->scenemanager_ = scenemanager;
     }
 
-    void BillboardSet::setBillboardSet(const std::string& file, const Vector3& position, int count)
+    void BillboardSet::setBillboardSet(Ogre::SceneManager* scenemanager, const std::string& file, const Vector3& position, int count)
     {
+        assert(scenemanager);
+
         std::ostringstream name;
         name << (BillboardSet::billboardSetCounter_s++);
-        this->billboardSet_ = GraphicsEngine::getInstance().getLevelSceneManager()->createBillboardSet("Billboard" + name.str(), count);
+        this->billboardSet_ = scenemanager->createBillboardSet("Billboard" + name.str(), count);
         this->billboardSet_->createBillboard(position);
         this->billboardSet_->setMaterialName(file);
+
+        this->scenemanager_ = scenemanager;
     }
 
-    void BillboardSet::setBillboardSet(const std::string& file, const ColourValue& colour, const Vector3& position, int count)
+    void BillboardSet::setBillboardSet(Ogre::SceneManager* scenemanager, const std::string& file, const ColourValue& colour, const Vector3& position, int count)
     {
+        assert(scenemanager);
+
         std::ostringstream name;
         name << (BillboardSet::billboardSetCounter_s++);
-        this->billboardSet_ = GraphicsEngine::getInstance().getLevelSceneManager()->createBillboardSet("Billboard" + name.str(), count);
+        this->billboardSet_ = scenemanager->createBillboardSet("Billboard" + name.str(), count);
         this->billboardSet_->createBillboard(position, colour);
         this->billboardSet_->setMaterialName(file);
+
+        this->scenemanager_ = scenemanager;
     }
 
     BillboardSet::~BillboardSet()
     {
-        if (this->billboardSet_)
-            GraphicsEngine::getInstance().getLevelSceneManager()->destroyBillboardSet(this->billboardSet_);
+        if (this->billboardSet_ && this->scenemanager_)
+            this->scenemanager_->destroyBillboardSet(this->billboardSet_);
     }
 }
